/*!
* @file Building.h
* @brief 施設のプロトタイプ宣言
* @date 2014/02/01
* @author Deskull
* 2014 Sikabane Works.
*/

#pragma once

#include "stdafx.h"
#include "Deeangband.h"
#include "GameElement.h"

namespace Deeangband
{

	/*! 
	* @class Building
	* @brief 施設のクラス
	*/
	class Building : public GameElement
	{
	private:

		friend class boost::serialization::access;

		/*!
		* @brief クラスのシリアライズを設定する
		* @param archive アーカイブ化するクラスのアドレス
		* @param version ファイルバージョン
		* @return XMLSerializeテンプレート
		*/
		template<class Archive> void serialize(Archive &archive, const unsigned int version) 
		{
			if(version >= 0)
			{
				archive & boost::serialization::make_nvp("Name", name);
			}
		}

	public:

		/*! 
		* @brief Buildingクラスコンストラクタ
		*/
		Building::Building(void);

		/*! 
		* @brief Buildingクラスデストラクタ
		*/
		Building::~Building(void);

		/*! 
		* @brief Buildingデータ消去
		* @return なし
		*/
		void Building::WipeData(void);
	};

}


BOOST_CLASS_VERSION(Deeangband::Building, 10);
